/** cosinus.java - jpq - 07/09/99 - 21/11/99
 * jdk1.2 - double-buffering
 * modification et ajout de main() le 13/01/18. Adaptation SE18 25/09/22
 */

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import geo.*;

public class cosinus extends Panel implements MouseListener, MouseMotionListener {
	static final long serialVersionUID = 220925L;
	static Image img;
	static Graphics g;
	static Repere R, R1, R2;
	static Pt O, S, I, K, L, N, P, Q, C;
	static PointSurDroite J, O1;
	static Cercle Ce, Cenr;
	static ArcDeCercle IM, CS;
	static Droite xpx, ypy;
	static PointSurCercle M;
	static Segment SQ, NP, SP, O1N, OM, OQ, CM;
	static CourbeFonction cfc;
	static cos fc;
	int aNp, Nperiodes = 0;
	double ap = 1.0;
	int X, Y;
	double pis2 = Math.PI / 2.0;
	double pi3s2 = Math.PI * 1.5;
	double pi2 = Math.PI + Math.PI;
	int gw, gh;
	
	public cosinus() {
		setBackground (Color.WHITE);
		addMouseMotionListener (this);
		addMouseListener (this);
		Nperiodes = 0;
	}

	public void update (Graphics g) {
		paint (g);
	}

	private double arrondi (double d) {
		return 0.01 * Math.floor (d * 100.0);
	}

	public void paint (Graphics g1) {
		if (img == null || gw != getSize().width || gh != getSize().height) {
			gw = getSize().width;
			gh = getSize().height;
			img = createImage (gw, gh);
			g = img.getGraphics ();
			g.setFont (new Font ("Arial", Font.PLAIN, 10));

			R = new Repere (getSize().height / 2, getSize().height / 2, getSize().width, getSize().height, (double)(getSize().height / 2 - 20), (double)(getSize().height / 2 - 20));
			O = new Pt (0.0, 0.0);
			xpx = new Droite (0.0, 1.0, 0.0);
			ypy = new Droite (1.0, 0.0, 0.0);
			O1 = new PointSurDroite (3.0, 0.0, xpx);
			I = new Pt (1.0, 0.0);
			J = new PointSurDroite (0.0, 1.0, ypy);
			R1 = new Repere (R.X(O1.x), R.Y(O1.y), gw, gh, R.unitex, R.unitey);
			K = new Pt (- 1.0, 0.0);
			L = new Pt (0.0, -1.0);
			Ce = new Cercle (O, 1.0);
			Cenr = new Cercle (O, 1.0);
			M = new PointSurCercle (1.0, Ce);
			C = new Pt (M.x, 0.0); 
			S = new Pt (0.0, M.x);
			Q = new Pt (- M.y, M.x);
			SQ = new Segment (S, Q);
			OQ = new Segment (O, Q);
			OM = new Segment (O, M);
			CM = new Segment (C, M);
			CS = new ArcDeCercle (0.0, 0.0, M.x, 0.0, pis2);
			ypy = new Droite (1.0, 0.0, - O.x);
			IM = new ArcDeCercle (0.0, 0.0, 1.0, 0.0, 1.0);
			N = new Pt (O1.x + 1.0, 0.0);
			P = new Pt (O1.x + 1.0, M.x);
			NP = new Segment (N, P);
			SP = new Segment (S, P);
			O1N = new Segment (O1, N);
			fc = new cos();
			cfc = new CourbeFonction (fc);
		}

		g.setColor (getBackground());
		g.fillRect (0, 0, R.XMAX, R.YMAX);

		if (J.deplace) {
			if (J.y > 0.0) {
				double uy = (double) (R.Y0 - R.Y (J.y));
				R.MAJ (gh / 2, gh / 2, gw, gh, uy, uy);
			} else
				J.MAJ (0.0, 1.0);
		}
		if (J.deplace || O1.deplace)
			R1.MAJ (R.X(O1.x), R.Y(O1.y), gw, gh, R.unitex, R.unitey);
		C.MAJ (M.x, 0.0);
		S.MAJ (0.0, M.x);
		Q.MAJ (- M.y, M.x);
		double Ma = M.a + pi2 * Nperiodes;
		double Maa = M.a;
		aNp = Math.abs (Nperiodes);
		if ((M.a < 0.0) && (Nperiodes > 0)) {
			aNp --;
			Maa = Maa + pi2;
		} else if ((M.a > 0.0) && (Nperiodes < 0)) {
			aNp --;
			Maa = Maa - pi2;
		}
		IM.MAJ (0.0, 0.0, 1.0 + R.x (aNp + R.X0), 0.0, Maa);
		N.MAJ (O1.x + Ma, 0.0);
		P.MAJ (O1.x + Ma, M.x);
		NP.MAJ (N, P);
		SP.MAJ (S, P);
		O1N.MAJ (O1, N);

		SQ.MAJ (S, Q);
		OQ.MAJ (O, Q);
		OM.MAJ (O, M);
		CM.MAJ (C, M);
		if (M.x >= 0)
			CS.MAJ (0.0, 0.0, M.x, 0.0, pis2);
		else
			CS.MAJ (0.0, 0.0, - M.x, Math.PI, pis2);

		g.setColor (Color.BLACK);
		g.drawString ("(" + Double.toString (arrondi(R1.x(X))) + ", " + Double.toString (arrondi(R1.y(Y))) + ")", 2, gh - 20);

		g.setColor (Color.MAGENTA);
		SQ.trace ("", R, g);
		CM.trace ("", R, g);
		CS.trace ("", R, g);

		g.setColor (Color.RED);
		R.trace (g);
		R1.trace (g);
		O.traceNom ("O", R, g);
		O1.trace ("O1", R, g);
		J.trace ("J", R, g);
		M.trace ("M", R, g);

		g.setColor (Color.BLUE);
		Ce.trace ("", R, g);
		K.traceNom ("K", R, g);
		L.traceNom ("L", R, g);

		g.setColor (Color.CYAN);
		cfc.trace ("", R1, g);

		g.setColor (Color.GREEN);
		NP.trace ("", R, g);
		SP.trace ("", R, g);

		g.setColor (Color.BLACK);
//		R.cadre (g);
		P.trace ("P", R, g);
		for (int i = 0; i < aNp; i ++) {
			Cenr.MAJ (0.0, 0.0, 1.0 + R.x (i + R.X0));
			Cenr.trace ("", R, g);
		}
		IM.trace (false, "", R, g);
		O1N.trace ("", R, g);
		OQ.trace ("", R, g);
		OM.trace ("", R, g);
		I.traceNom ("I", R, g);
		S.traceNom ("S", R, g);
		Q.traceNom ("Q", R, g);
		N.traceNom ("N", R, g);
		C.traceNom ("C", R, g);

		g1.drawImage (img, 0, 0, this);
	}

	public void mousePressed (MouseEvent e) {
		X = e.getX();
		Y =  e.getY();
		if (M.deplace = M.zone (X, Y, R)) {
		} else if (J.deplace = J.zone (X, Y, R)) {
		} else if (O1.deplace = O1.zone (X, Y, R)) {
		}
	}

	public void mouseDragged (MouseEvent e) {
		X = e.getX();
		Y =  e.getY();
		M.bouge (X, Y, R);
		J.bouge (X, Y, R);
		O1.bouge (X, Y, R);
		repaint();
	}

	public void mouseReleased (MouseEvent e) {
		M.deplace = J.deplace = O1.deplace = false;
	}

	public void mouseMoved (MouseEvent e) {
		X = e.getX();
		Y = e.getY();
		if (M != null && M.zone (X, Y, R) || J != null && J.zone (X, Y, R) || O1 != null && O1.zone (X, Y, R)) {
			setCursor (new Cursor (Cursor.HAND_CURSOR));
		} else {
			setCursor (new Cursor (Cursor.DEFAULT_CURSOR));
		}
		repaint();
	}

	public void mouseClicked (MouseEvent e) {}
	public void mouseEntered (MouseEvent e) {}
	public void mouseExited (MouseEvent e) {}

	public static void main (String [] args) {
		int w = 800;
		int h = 300;
		cosinus fcos = new cosinus();
		JFrame f = new JFrame ("cosinus");
		f.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		f.add (fcos);
		f.setSize (w, h);
		f.setVisible (true);
	}

/**
 * Fonction cosinus
 */
protected class cos extends Fonction {

	public boolean defini (double x) {
		return true;
	}

	public double Image (double x) {
		return Math.cos (x);
	}

}

}
